
-- reference a database
use DataScience
go


--/*

--conditionally create a table based on a file
drop table if exists dbo.qqq_jan_may_2021;

create table dbo.qqq_jan_may_2021 (
date date,
[open] money,
[high] money,
[low] money,
[close] money,
[volume] bigint
)

-- bulk insert with SQL Server
bulk insert dbo.qqq_jan_may_2021
from 'c:\DataScienceSamples\QQQ_Jan_May_2021.csv'
with (format='csv',firstrow = 2);

-- display imported csv file
--select * from dbo.qqq_jan_may_2021

-- conditionally create table for close and emas
drop table if exists dbo.qqq_jan_may_2021_with_ema_cols;

create table dbo.qqq_jan_may_2021_with_ema_cols (
row_number bigint,
date date,
[close] money,
ema_10 money,
ema_20 money,
ema_30 money
)

insert dbo.qqq_jan_may_2021_with_ema_cols
(
row_number,
date,
[close]
)
select row_number() over (order by date) row_number, date, [close] from dbo.qqq_jan_may_2021

select * from dbo.qqq_jan_may_2021_with_ema_cols

--*/

--/*

-- declarations for ema weights
declare 
 @ema_10_alpha float = (2.0/11.0)
,@ema_20_alpha float = (2.0/21.0)
,@ema_30_alpha float = (2.0/31.0)

-- there are no ema's on row_number 1 by definition

-- assign values to ema's on row_number 2
-- simple definition is to use close from row_number 1
update dbo.qqq_jan_may_2021_with_ema_cols
set ema_10 = (select [close] from dbo.qqq_jan_may_2021_with_ema_cols where row_number = 1),
	ema_20 = (select [close] from dbo.qqq_jan_may_2021_with_ema_cols where row_number = 1),
	ema_30 = (select [close] from dbo.qqq_jan_may_2021_with_ema_cols where row_number = 1)
where row_number = 2;


declare 
 @current_rownumber bigint = 3
,@prior_rownumber bigint = 2
,@count_of_rows bigint = 
	(select count(*) from dbo.qqq_jan_may_2021_with_ema_cols)

--select count(*)
--from dbo.qqq_jan_may_2021_with_ema_cols

while @current_rownumber <= @count_of_rows
begin

	--select @prior_rownumber, @current_rownumber, @count_of_rows
-- assign values to ema's on row_number 3 and beyond
	update dbo.qqq_jan_may_2021_with_ema_cols
	set ema_10 = @ema_10_alpha*(select [close] from dbo.qqq_jan_may_2021_with_ema_cols where row_number = @current_rownumber) 
			+ (1-@ema_10_alpha)*(select [ema_10] from dbo.qqq_jan_may_2021_with_ema_cols where row_number = @prior_rownumber),
		ema_20 = @ema_20_alpha*(select [close] from dbo.qqq_jan_may_2021_with_ema_cols where row_number = @current_rownumber)
			+ (1-@ema_20_alpha)*(select [ema_20] from dbo.qqq_jan_may_2021_with_ema_cols where row_number = @prior_rownumber),
		ema_30 = @ema_30_alpha*(select [close] from dbo.qqq_jan_may_2021_with_ema_cols where row_number = @current_rownumber)
			+ (1-@ema_30_alpha)*(select [ema_30] from dbo.qqq_jan_may_2021_with_ema_cols where row_number = @prior_rownumber)
	where row_number = @current_rownumber;

	set @prior_rownumber = @prior_rownumber + 1
	set @current_rownumber = @current_rownumber + 1

end

select *  from dbo.qqq_jan_may_2021_with_ema_cols

--*/



























--/*


-- REDO emas for Jan_2018 through May_2021

--conditionally create a table based on a file
drop table if exists dbo.qqq_jan_2018_may_2021;

create table dbo.qqq_jan_2018_may_2021 (
date date,
[open] money,
[high] money,
[low] money,
[close] money,
[volume] bigint
)

-- bulk insert with SQL Server
bulk insert dbo.qqq_jan_2018_may_2021
from 'c:\DataScienceSamples\QQQ_Jan_2018_May_2021.csv'
with (format='csv',firstrow = 2);

-- display imported csv file
select * from dbo.qqq_jan_2018_may_2021

-- conditionally create table for close and emas
drop table if exists dbo.qqq_jan_2018_may_2021_with_ema_cols;

create table dbo.qqq_jan_2018_may_2021_with_ema_cols (
row_number bigint,
date date,
[close] money,
ema_10 money,
ema_20 money,
ema_30 money
)

insert dbo.qqq_jan_2018_may_2021_with_ema_cols
(
row_number,
date,
[close]
)
select row_number() over (order by date) row_number, date, [close] from dbo.qqq_jan_2018_may_2021



go
declare 
 @ema_10_alpha float = (2.0/11.0)
,@ema_20_alpha float = (2.0/21.0)
,@ema_30_alpha float = (2.0/31.0)

-- there are no ema's on row_number 1 by definition

-- assign values to ema's on row_number 2
-- simple definition is to use close from row_number 1
update dbo.qqq_jan_2018_may_2021_with_ema_cols
set ema_10 = (select [close] from dbo.qqq_jan_2018_may_2021_with_ema_cols where row_number = 1),
	ema_20 = (select [close] from dbo.qqq_jan_2018_may_2021_with_ema_cols where row_number = 1),
	ema_30 = (select [close] from dbo.qqq_jan_2018_may_2021_with_ema_cols where row_number = 1)
where row_number = 2;


declare 
 @current_rownumber bigint = 3
,@prior_rownumber bigint = 2
,@count_of_rows bigint = 
	(select count(*) from dbo.qqq_jan_2018_may_2021_with_ema_cols)

--select count(*)
--from dbo.qqq_jan_2018_may_2021_with_ema_cols

while @current_rownumber <= @count_of_rows
begin

	--select @prior_rownumber, @current_rownumber, @count_of_rows
-- assign values to ema's on row_number 3 and beyond
	update dbo.qqq_jan_2018_may_2021_with_ema_cols
	set ema_10 = @ema_10_alpha*(select [close] from dbo.qqq_jan_2018_may_2021_with_ema_cols where row_number = @current_rownumber) 
			+ (1-@ema_10_alpha)*(select [ema_10] from dbo.qqq_jan_2018_may_2021_with_ema_cols where row_number = @prior_rownumber),
		ema_20 = @ema_20_alpha*(select [close] from dbo.qqq_jan_2018_may_2021_with_ema_cols where row_number = @current_rownumber)
			+ (1-@ema_20_alpha)*(select [ema_20] from dbo.qqq_jan_2018_may_2021_with_ema_cols where row_number = @prior_rownumber),
		ema_30 = @ema_30_alpha*(select [close] from dbo.qqq_jan_2018_may_2021_with_ema_cols where row_number = @current_rownumber)
			+ (1-@ema_30_alpha)*(select [ema_30] from dbo.qqq_jan_2018_may_2021_with_ema_cols where row_number = @prior_rownumber)
	where row_number = @current_rownumber;

	set @prior_rownumber = @prior_rownumber + 1
	set @current_rownumber = @current_rownumber + 1

end

select *  from dbo.qqq_jan_2018_may_2021_with_ema_cols



