
-- reference a database
use DataScience
go


--/*

--conditionally create a table
drop table if exists dbo.qqq_jan_may_2021;

create table dbo.qqq_jan_may_2021 (
date date,
[open] money,
[high] money,
[low] money,
[close] money,
[volume] bigint
)

-- bulk insert with SQL Server
bulk insert dbo.qqq_jan_may_2021
from 'c:\DataScienceSamples\QQQ_Jan_May_2021.csv'
with (format='csv',firstrow = 2);

-- display imported csv file
select * from dbo.qqq_jan_may_2021

--*/


--/*

-- create a fresh copy of dbo.close_sma_10_sma_20_sma_30
drop table if exists dbo.close_sma_10_sma_20_sma_30;


-- compute 10, 20, and 30 period sma's
select 
 date date
,[close] [close]
-- for ten-period moving average
,
case
   when row_number() OVER(ORDER BY [Date]) > 9
      then avg([Close]) OVER(ORDER BY [Date] ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
   else null
end sma_10
-- for twenty-period moving average
,
case
   when row_number() over(order by [date]) > 19
      then avg([close]) over(order by [date] rows between 19 preceding and current row)
   else null
end sma_20
-- for thirty-period moving average
,
case
   when row_number() over(order by [date]) > 29
      then avg([close]) over(order by [date] rows between 29 preceding and current row)
   else null
end sma_30
into dbo.close_sma_10_sma_20_sma_30
from dbo.qqq_jan_may_2021


select * from dbo.close_sma_10_sma_20_sma_30

--*/





--conditionally create a table
drop table if exists dbo.qqq_jan_2018_may_2021;

create table dbo.qqq_jan_2018_may_2021 (
date date,
[open] money,
[high] money,
[low] money,
[close] money,
[volume] bigint
)

-- bulk insert with SQL Server
bulk insert dbo.qqq_jan_2018_may_2021
from 'c:\DataScienceSamples\QQQ_Jan_2018_May_2021.csv'
with (format='csv',firstrow = 2);

-- display imported csv file
select * from dbo.qqq_jan_2018_may_2021





-- create a fresh copy of dbo.close_sma_10_sma_20_sma_30
drop table if exists dbo.close_from_2018_sma_10_sma_20_sma_30;


-- compute 10, 20, and 30 period sma's
select 
 date date
,[close] [close]
-- for ten-period moving average
,
case
   when row_number() OVER(ORDER BY [Date]) > 9
      then avg([Close]) OVER(ORDER BY [Date] ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
   else null
end sma_10
-- for twenty-period moving average
,
case
   when row_number() over(order by [date]) > 19
      then avg([close]) over(order by [date] rows between 19 preceding and current row)
   else null
end sma_20
-- for thirty-period moving average
,
case
   when row_number() over(order by [date]) > 29
      then avg([close]) over(order by [date] rows between 29 preceding and current row)
   else null
end sma_30
into dbo.close_from_2018_sma_10_sma_20_sma_30
from dbo.qqq_jan_2018_may_2021


select * from dbo.close_from_2018_sma_10_sma_20_sma_30


--select * from dbo.close_sma_10_sma_20_sma_30
